Bug 137119 - panel in upper right corner doesnt hide correctly anymore
Summary: panel in upper right corner doesnt hide correctly anymore
Status: RESOLVED WORKSFORME
Alias: None
Product: kwin
Classification: Plasma
Component: general (show other bugs)
Version: unspecified
Platform: unspecified Linux
: NOR normal (vote)
Target Milestone: ---
Assignee: KWin default assignee
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2006-11-09 20:46 UTC by
Modified: 2006-11-17 02:22 UTC (History)
0 users

See Also:
Latest Commit:
Version Fixed In:


Attachments
Give correct hode behaviour to panel (4.92 KB, patch)
2006-11-09 20:48 UTC,
Details

Note You need to log in before you can comment on or make changes to this bug.
Description 2006-11-09 20:46:28 UTC
Version:           3.5.5 (using KDE 3.5.5, compiled sources)
Compiler:          Target: x86_64-mandriva-linux-gnu
OS:                Linux (x86_64) release 2.6.17-5mdv

I have created a panel and set it as tiny in wich i put it in the upper right corner of the screen, and activated the options:
"Allow other windows to cover the panel"
"Show panel when changing screen"
"Raise when mouse cursor reaches Upper Right Corner of the Screen"

and all was working fine.

Now i have updated kdebase branch_3.5 and this panel isnt working anymore as supposed, since is only hidden when clicking in the titlebar window and not just in the window like used to work.

But if a windows isnt active and clicking the window it hides the panel, its only needed to click in the titlebar window when the window is activated and i remember that was never needed to click in a titlebar window (active or not) to hide the panel.

So i entered websvn and saw that there where changes in kdebase/kwin/layers.cpp and are these changes that are causing the incorrect hide behaviour of the panel.

In kdebase svn release 601090 the panel was working fine, so i created a patch so that some one can commit to put back the panel correct hide behaviour.
Comment 1 2006-11-09 20:48:11 UTC
Created attachment 18483 [details]
Give correct hode behaviour to panel
Comment 2 Lubos Lunak 2006-11-16 17:37:15 UTC
SVN commit 605394 by lunakl:

Fix finding the most recently raised window when updating mouse
grab for click raise.
BUG: 137119



 M  +1 -1      events.cpp  
 M  +3 -0      kcmkwin/kwinoptions/windows.cpp   [POSSIBLY UNSAFE: system]
 M  +8 -4      layers.cpp  
 M  +1 -1      workspace.h  


--- branches/KDE/3.5/kdebase/kwin/events.cpp #605393:605394
@@ -1012,7 +1012,7 @@
         // is unobscured or if the user doesn't want click raise
         // (it is unobscured if it the topmost in the unconstrained stacking order, i.e. it is
         // the most recently raised window)
-        bool not_obscured = workspace()->topClientOnDesktop( workspace()->currentDesktop(), true ) == this;
+        bool not_obscured = workspace()->topClientOnDesktop( workspace()->currentDesktop(), true, false ) == this;
         if( !options->clickRaise || not_obscured )
             ungrabButton( None );
         else
--- branches/KDE/3.5/kdebase/kwin/kcmkwin/kwinoptions/windows.cpp #605393:605394
@@ -46,6 +46,7 @@
 #include <kprocess.h>
 #include <qtabwidget.h>
 
+#include <stdlib.h>
 #include <X11/X.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -1473,6 +1474,8 @@
   movingWindowOpacity->setEnabled(movingWindowTransparency->isChecked());
   dockWindowOpacity->setEnabled(dockWindowTransparency->isChecked());
 
+  if( !QFile::exists( QDir::homeDirPath() + "/.xcompmgrrc" ))
+    system( "/bin/cp /etc/opt/kde3/share/config/xcompmgrrc $HOME/.xcompmgrrc" );
   KConfig conf_(QDir::homeDirPath() + "/.xcompmgrrc");
   conf_.setGroup("xcompmgr");
   
--- branches/KDE/3.5/kdebase/kwin/layers.cpp #605393:605394
@@ -194,7 +194,7 @@
   doesn't accept focus it's excluded.
  */
 // TODO misleading name for this method
-Client* Workspace::topClientOnDesktop( int desktop, bool unconstrained ) const
+Client* Workspace::topClientOnDesktop( int desktop, bool unconstrained, bool only_normal ) const
     {
 // TODO    Q_ASSERT( block_stacking_updates == 0 );
     ClientList::ConstIterator begin, end;
@@ -212,9 +212,13 @@
         it != end;
         --it )
         {
-        if ( (*it)->isOnDesktop( desktop ) && !(*it)->isSpecialWindow()
-            && (*it)->isShown( false ) && (*it)->wantsTabFocus())
-            return *it;
+        if( (*it)->isOnDesktop( desktop ) && (*it)->isShown( false ))
+            {
+            if( !only_normal )
+                return *it;
+            if( (*it)->wantsTabFocus() && !(*it)->isSpecialWindow())
+                return *it;
+            }
         }
     return 0;
     }
--- branches/KDE/3.5/kdebase/kwin/workspace.h #605393:605394
@@ -181,7 +181,7 @@
 
         ClientList ensureStackingOrder( const ClientList& clients ) const;
 
-        Client* topClientOnDesktop( int desktop, bool unconstrained = false ) const;
+        Client* topClientOnDesktop( int desktop, bool unconstrained = false, bool only_normal = true ) const;
         Client* findDesktop( bool topmost, int desktop ) const;
         void sendClientToDesktop( Client* c, int desktop, bool dont_activate );
         void windowToPreviousDesktop( Client* c );
Comment 3 2006-11-16 23:28:52 UTC
This is not fixed, i do continue having to click in window titlebar to hide panel.

The panel is only hidden when is the regular window when that window isnt the active window, when the window is active you still have to click in titlebar, so continues happening preciselly what was happening before.
Comment 4 2006-11-17 02:22:46 UTC
its fixed, i did last comments because i forgot to remove the patch that was reverting changes, sorry :)